﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/messages_cap.ini")

# ******************** Load ********************
def load():
	create_popup()

	es.load("soccer_mod_2010/cap/fights")
	es.load("soccer_mod_2010/cap/pick")

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/popup_admin_cap.ini")

	popup = popuplib.create("sm_popup_admin_cap")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")
	popup.addline("->1. %s" % (text("spectator")))
	popup.addline("->2. %s" % (text("fights")))
	popup.addline("->3. %s" % (text("random_player")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, spec_all)
	popup.submenu(2, "sm_popup_admin_cap_fights")
	popup.select(3, random_player)
	popup.submenu(4, "sm_popup_admin_cap")
	popup.submenu(5, "sm_popup_admin_cap")
	popup.submenu(6, "sm_popup_admin_cap")
	popup.submenu(7, "sm_popup_admin_cap")
	popup.submenu(8, "sm_popup_admin_cap")
	popup.submenu(9, "sm_popup_admin")

# ******************** Popup choices ********************
def spec_all(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("match") == 0:
		if es.ServerVar("cap_fight") == 0:
			lang_msg("cap_start", tokens, 1)

			for ply in playerlib.getPlayerList("#human"):
				if ply.team > 1:
					es.server.queuecmd("es_changeteam %s 1" % (ply.userid))

				es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, messages("cap_start", tokens, ply.get("lang"))))

			tokens["name"] = player.name
			lang_msg("spec", tokens, 0)
		else:
			es.tell(userid, "#green", messages("no_spec_fight", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_spec_match", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_cap", userid)

def random_player(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("cap_fight") == 0:
		if es.ServerVar("match") == 0:
			ts = int(es.getplayercount(2))
			cts = int(es.getplayercount(3))

			if ts == cts:
				force_random_player(userid, 2)
			elif ts < cts:
				force_random_player(userid, 2)
			elif ts > cts:
				force_random_player(userid, 3)
		else:
			es.tell(userid, "#green", messages("no_random_player_match", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_random_player_fight", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_cap", userid)

# ******************** Functions ********************
def lang_msg(text, tokens, center, team = None):
	for player in playerlib.getPlayerList("#human"):
		if team != None:
			tokens["team"] = messages(team, tokens, player.get("lang"))
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def force_random_player(userid, team):
	tokens = {}
	player = playerlib.getPlayer(userid)
	myPlayerList = playerlib.getPlayerList("#spec,#human")

	length = len(myPlayerList)
	if length > 0:
		length -= 1
		if length > 0:
			number = random.randint(0, length)
		else:
			number = 0

		es.server.queuecmd("es_changeteam %s %s" % (myPlayerList[number], team))

		tokens["name"] = es.getplayername(userid)
		tokens["target"] = es.getplayername(myPlayerList[number])
		lang_msg("random_player", tokens, 0)
	else:
		es.tell(userid, "#green", messages("no_player_available", tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_cap")

	es.unload("soccer_mod_2010/cap/fights")
	es.unload("soccer_mod_2010/cap/pick")