﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/messages_cap_fights.ini")

# ******************** Load ********************
def load():
	load_variables()
	create_popup()

# ******************** Events ********************
def es_map_start(event_var):
	load_variables()

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("cap_fight") == 1:
			player = playerlib.getPlayer(event_var["userid"])
			if player.team > 1:
				if es.ServerVar("sm_cap_fight_frozen") == 0:
					type = es.ServerVar("sm_cap_fight_type")
					if type == "hegrenade":
						es.server.queuecmd("es_give %s weapon_hegrenade" % (event_var["userid"]))
					elif type == "weapon_1":
						es.server.queuecmd("es_give %s weapon_%s" % (event_var["userid"], es.ServerVar("sm_cap_weapon_1")))
					elif type == "weapon_2":
						es.server.queuecmd("es_give %s weapon_%s" % (event_var["userid"], es.ServerVar("sm_cap_weapon_2")))
					elif type == "weapon_3":
						es.server.queuecmd("es_give %s weapon_%s" % (event_var["userid"], es.ServerVar("sm_cap_weapon_3")))
					elif type == "high_speed":
						player.setSpeed(2)
				else:
					player.freeze(1)

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("cap_fight") == 1:
			load_variables()

def hegrenade_detonate(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("cap_fight") == 1:
			if es.ServerVar("sm_cap_fight_frozen") == 0:
				if es.ServerVar("sm_cap_fight_type") == "hegrenade":
					player = playerlib.getPlayer(event_var["userid"])
					if player.isdead == 0:
						if player.getHE() == 0:
							es.server.queuecmd("es_give %s weapon_hegrenade" % (event_var["userid"]))

def round_end(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("cap_fight") == 1:
			load_variables()

# ******************** Load variables ********************
def load_variables():
	es.set("cap_fight", 0)
	es.set("sm_cap_fight_frozen", 0)
	es.set("sm_cap_fight_type", 0)

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/popup_admin_cap_fights.ini")

	popup = popuplib.create("sm_popup_admin_cap_fights")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")
	popup.addline("->1. %s" % (text("knife")))
	popup.addline("->2. %s" % (text("hegrenade")))

	tokens = {}

	tokens["weapon"] = es.ServerVar("sm_cap_weapon_1")
	popup.addline("->3. %s" % (text("weapon", tokens)))

	tokens["weapon"] = es.ServerVar("sm_cap_weapon_2")
	popup.addline("->4. %s" % (text("weapon", tokens)))

	tokens["weapon"] = es.ServerVar("sm_cap_weapon_3")
	popup.addline("->5. %s" % (text("weapon", tokens)))

	popup.addline("->6. %s" % (text("high_speed")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, freeze)
	popup.select(2, freeze)
	popup.select(3, freeze)
	popup.select(4, freeze)
	popup.select(5, freeze)
	popup.select(6, freeze)
	popup.submenu(7, "sm_popup_admin_cap_fights")
	popup.submenu(8, "sm_popup_admin_cap_fights")
	popup.submenu(9, "sm_popup_admin_cap")

# ******************** Popup choices ********************
def freeze(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("match") == 0:
		if es.ServerVar("cap_fight") == 0:
			for player in playerlib.getPlayerList("#alive"):
				player.freeze(1)

			es.set("cap_fight", 1)
			es.set("sm_cap_fight_type", 0)
			es.set("sm_cap_fight_frozen", 1)
			es.set("sm_cap_fight_weapon", 0)

			tokens["name"] = player.name

			if choice == 1:
				es.set("sm_cap_fight_type", "knife")

				for ply in playerlib.getPlayerList("#human"):
					es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, messages("ready_knife", tokens, ply.get("lang"))))

				lang_msg("knife", tokens)
			elif choice == 2:
				es.set("sm_cap_fight_type", "hegrenade")
				es.set("sm_cap_fight_weapon", "weapon_hegrenade")

				for ply in playerlib.getPlayerList("#human"):
					es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, messages("ready_hegrenade", tokens, ply.get("lang"))))

				lang_msg("hegrenade", tokens)
			elif choice == 3 or choice == 4 or choice == 5:
				if choice == 3:
					es.set("sm_cap_fight_type", "weapon_1")
					value = es.ServerVar("sm_cap_weapon_1")
				elif choice == 4:
					es.set("sm_cap_fight_type", "weapon_2")
					value = es.ServerVar("sm_cap_weapon_2")
				elif choice == 5:
					es.set("sm_cap_fight_type", "weapon_3")
					value = es.ServerVar("sm_cap_weapon_3")

				es.set("sm_cap_fight_weapon", "weapon_%s" % (value))

				tokens["weapon"] = value

				for ply in playerlib.getPlayerList("#human"):
					es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, messages("ready_weapon", tokens, ply.get("lang"))))

				lang_msg("weapon", tokens)
			elif choice == 6:
				es.set("sm_cap_fight_type", "high_speed")

				for ply in playerlib.getPlayerList("#human"):
					es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, messages("ready_high_speed", tokens, ply.get("lang"))))

				lang_msg("high_speed", tokens)

			lang_msg("prepare_fight", tokens, 1)
			gamethread.delayed(1, lang_msg, ("prepare_fight", tokens, 1))
			gamethread.delayed(2, tell_all, ("| 3 |"))
			gamethread.delayed(3, tell_all, ("| 2 |"))
			gamethread.delayed(4, tell_all, ("| 1 |"))
			gamethread.delayed(5, lang_msg, ("fight", tokens, 1))

			gamethread.delayed(5, start, (choice))
		else:
			es.tell(userid, "#green", messages("fight_already_started", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_fight_match", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_cap_fights", userid)

# ******************** Functions ********************
def lang_msg(text, tokens, center = 0):
	for player in playerlib.getPlayerList("#human"):
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def tell_all(message):
	for player in playerlib.getPlayerList("#human"):
		es.centertell(player.userid, message)

def start(choice):
	if es.ServerVar("cap_fight") == 1:
		es.set("sm_cap_fight_frozen", 0)

		weapon = es.ServerVar("sm_cap_fight_weapon")

		for player in playerlib.getPlayerList("#alive"):
			player.godmode(0)
			player.freeze(0)
			player.health = 100

			if weapon != "0":
				es.server.queuecmd("es_give %s %s" % (player.userid, weapon))
			else:
				if es.ServerVar("sm_cap_fight_type") == "high_speed":
					player.setSpeed(2)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_cap_fights")