﻿import es
import gamethread
import langlib
import playerlib
import popuplib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/messages_cap_fights.ini")

# ******************** Events ********************
def player_death(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("cap_fight") == 1:
			es.set("sm_cap_winner_userid", event_var["attacker"])
			es.set("sm_cap_loser_userid", event_var["userid"])

def round_end(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("cap_fight") == 1:
			es.set("sm_cap_winner_pick", 1)
			es.set("sm_cap_winner_number", 5)
			es.set("sm_cap_loser_number", 5)

			userid = es.ServerVar("sm_cap_winner_userid")
			send_pick_menu(userid)

			if int(event_var["winner"]) > 1:
				tokens = {}
				tokens["command"] = es.ServerVar("sm_cmd_cap_pick")

				if userid > 1:
					player = playerlib.getPlayer(userid)
					es.tell(userid, "#green", messages("pick_command", tokens, player.get("lang")))

				value = es.ServerVar("sm_cap_loser_userid")
				if value > 1:
					player = playerlib.getPlayer(value)
					es.tell(value, "#green", messages("pick_command", tokens, player.get("lang")))

# ******************** Commands ********************
def cmd_pick():
	tokens = {}
	userid = int(es.getcmduserid())
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		winnerid = int(es.ServerVar("sm_cap_winner_userid"))
		loserid = int(es.ServerVar("sm_cap_loser_userid"))

		if int(es.ServerVar("sm_cap_winner_pick")) == 1:
			if winnerid == userid:
				if int(es.ServerVar("sm_cap_winner_number")) > 0:
					send_pick_menu(winnerid)
				else:
					es.tell(userid, "#green", messages("cant_pick_anymore", tokens, player.get("lang")))
			elif loserid == userid:
				es.tell(userid, "#green", messages("not_your_turn", tokens, player.get("lang")))
			else:
				es.tell(userid, "#green", messages("not_cap", tokens, player.get("lang")))
		else:
			if winnerid == userid:
				es.tell(userid, "#green", messages("not_your_turn", tokens, player.get("lang")))
			elif loserid == userid:
				if int(es.ServerVar("sm_cap_loser_number")) > 0:
					send_pick_menu(loserid)
				else:
					es.tell(userid, "#green", messages("cant_pick_anymore", tokens, player.get("lang")))
			else:
				es.tell(userid, "#green", messages("not_cap", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", common("not_allowed", tokens, player.get("lang")))

# ******************** Functions ********************
def send_pick_menu(userid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	myPlayerList = playerlib.getPlayerList("#human,#spec")
	if len(myPlayerList) > 0:
		create_player_menu(name, messages("select_player"), "#human,#spec", "none", "pick")
		popuplib.send(name, userid)
	"""
	else:
		es.tell(userid, "#green", messages("no_players_available", tokens, player.get("lang")))
	"""

def lang_msg(text, tokens, center = 0):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def create_player_menu(name, title, users, cancelmenu, block):
	if block == "pick":
		myPopup = popuplib.easymenu(name, None, pick)
	myPopup.settitle(title)

	myPlayerList = playerlib.getPlayerList(users)
	for player in myPlayerList:
		myPopup.addoption(player.userid, player.name)

def pick(userid, choice, keymenuname):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	cmd = "es_changeteam %s %s" % (choice, es.getplayerteam(userid))
	es.server.queuecmd(cmd)

	tokens = {}
	tokens["name"] = es.getplayername(userid)
	tokens["target"] = es.getplayername(choice)
	lang_msg("pick", tokens)

	winner_number = es.ServerVar("sm_cap_winner_number")
	loser_number = es.ServerVar("sm_cap_loser_number")
	if winner_number > 0 and loser_number > 0:
		if es.ServerVar("sm_cap_winner_pick") == 1:
			userid = es.ServerVar("sm_cap_loser_userid")
			es.set("sm_cap_winner_pick", 0)
			winner_number -= 1
			es.set("sm_cap_winner_number", winner_number)
		else:
			userid = es.ServerVar("sm_cap_winner_userid")
			es.set("sm_cap_winner_pick", 1)
			loser_number -= 1
			es.set("sm_cap_loser_number", loser_number)

		gamethread.delayed(0.1, send_pick_menu, (userid))