﻿import cmdlib
import es

modules = [
	"cap",
	"match",
	"referee",
	"shout",
	"skins",
	"sprint",
	"training"
]

# ******************** Load ********************
def load():
	cmdlib.registerServerCommand("soccer_mod_downloads", downloads, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_downloads_auto", downloads_auto, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_cmd_admin", client_admin, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_cmd_info", client_info, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_cmd_vote", client_vote, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_vote_length", vote_length, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_vote_percentage", vote_percentage, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_vote_sounds", vote_sounds, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_vote_sound_start", vote_sound_start, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_cap", module_cap, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_match", module_match, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_match_stats", module_match_stats, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_player", module_player, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_referee", module_referee, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_referee_warn", module_referee_warn, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_referee_punish", module_referee_punish, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_shout", module_shout, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_skins", module_skins, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_sprint", module_sprint, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_training", module_training, "Server Command")

	es.set("sm_downloads_on", 1)
	es.set("sm_downloads_auto_on", 1)

	es.set("sm_cmd_admin", "!menu")
	es.set("sm_cmd_info", "!info")
	es.set("sm_cmd_vote", "!vote")

	es.set("sm_vote_length", 30)
	es.set("sm_vote_percentage", 100)
	es.set("sm_vote_sounds_on", 1)
	es.set("sm_vote_sound_start", "soccer_mod/vote/prepare.mp3")

	es.set("sm_module_cap_on", 1)

	es.set("sm_module_match_on", 1)
	es.set("sm_module_match_stats_on", 1)

	es.set("sm_module_player_on", 1)

	es.set("sm_module_referee_on", 1)
	es.set("sm_module_referee_warn_on", 1)
	es.set("sm_module_referee_punish_on", 1)

	es.set("sm_module_shout_on", 1)

	es.set("sm_module_skins_on", 1)

	es.set("sm_module_sprint_on", 1)

	es.set("sm_module_training_on", 1)

	es.server.cmd("exec soccer_mod/soccer_mod.cfg")

	for row in modules:
		if es.ServerVar("sm_module_%s_on" % (row)) == 1:
			es.load("soccer_mod_2010/cfg/%s" % (row))

# ******************** Commands ********************
def downloads(args):
	set_boolean("sm_downloads_on", args[0])

def downloads_auto(args):
	set_boolean("sm_downloads_auto_on", args[0])

def client_admin(args):
	es.set("sm_cmd_admin", args[0])

def client_info(args):
	es.set("sm_cmd_info", args[0])

def client_vote(args):
	es.set("sm_cmd_vote", args[0])

def vote_length(args):
	set_int("sm_vote_length", args[0], 30)

def vote_percentage(args):
	set_int("sm_vote_percentage", args[0], 100)

def vote_sounds(args):
	set_boolean("sm_vote_sounds_on", args[0])

def vote_sound_start(args):
	es.set("sm_vote_sound_start", args[0])

def module_cap(args):
	set_boolean("sm_module_cap_on", args[0])

def module_match(args):
	set_boolean("sm_module_match_on", args[0])

def module_match_stats(args):
	set_boolean("sm_module_match_stats_on", args[0])

def module_player(args):
	set_boolean("sm_module_player_on", args[0])

def module_referee(args):
	set_boolean("sm_module_referee_on", args[0])

def module_referee_warn(args):
	set_boolean("sm_module_referee_warn_on", args[0])

def module_referee_punish(args):
	set_boolean("sm_module_referee_punish_on", args[0])

def module_shout(args):
	set_boolean("sm_module_shout_on", args[0])

def module_skins(args):
	set_boolean("sm_module_skins_on", args[0])

def module_sprint(args):
	set_boolean("sm_module_sprint_on", args[0])

def module_training(args):
	set_boolean("sm_module_training_on", args[0])

# ******************** Functions ********************
def set_boolean(name, value):
	try:
		if int(value) == 1:
			es.set(name, 1)
		else:
			es.set(name, 0)
	except ValueError:
		es.set(name, 0)

def set_int(name, value, default):
	try:
		es.set(name, int(value))
	except ValueError:
		es.set(name, default)

# ******************** Unload ********************
def unload():
	commands = [
		"soccer_mod_downloads",
		"soccer_mod_downloads_auto",
		"soccer_mod_cmd_admin",
		"soccer_mod_cmd_info",
		"soccer_mod_cmd_vote",
		"soccer_mod_vote_length",
		"soccer_mod_vote_percentage",
		"soccer_mod_vote_sounds",
		"soccer_mod_vote_sound_start",
		"soccer_mod_module_cap",
		"soccer_mod_module_match",
		"soccer_mod_module_match_stats",
		"soccer_mod_module_player",
		"soccer_mod_module_referee",
		"soccer_mod_module_referee_warn",
		"soccer_mod_module_referee_punish",
		"soccer_mod_module_shout",
		"soccer_mod_module_skins",
		"soccer_mod_module_sprint",
		"soccer_mod_module_training"
	]

	for cmd in commands:
		cmdlib.unregisterServerCommand(cmd)

	for row in modules:
		if es.ServerVar("sm_module_%s_on" % (row)) == 1:
			es.unload("soccer_mod_2010/cfg/%s" % (row))