﻿import cmdlib
import es

# ******************** Load ********************
def load():
	cmdlib.registerServerCommand("soccer_mod_match_cmd_stats", cmd_stats, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_stats_save_round_end", stats_save_round_end, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_match_cmd_start", match_start, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_cmd_pause", match_pause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_cmd_unpause", match_unpause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_cmd_stop", match_stop, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_match_swap_home_away", swap_home_away, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_round_start", sound_round_start, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_round_end", sound_round_end, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_period_end", sound_period_end, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_match_end", sound_match_end, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_match_rank_goal", rank_goal, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_rank_assist", rank_assist, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_rank_own_goal", rank_own_goal, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_rank_hit", rank_hit, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_rank_pass", rank_pass, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_rank_interception", rank_interception, "Server Command")

	es.set("sm_cmd_match_stats", "!stats")
	es.set("sm_match_stats_save_round_end", 0)

	es.set("sm_cmd_match_start", "!start")
	es.set("sm_cmd_match_pause", "!pause")
	es.set("sm_cmd_match_unpause", "!unpause")
	es.set("sm_cmd_match_stop", "!stop")

	es.set("sm_match_swap_home_away_on", 0)
	es.set("sm_match_sound_round_start", "soccer_mod/match/kickoff.wav")
	es.set("sm_match_sound_round_end", "soccer_mod/match/wickedsick.mp3")
	es.set("sm_match_sound_period_end", "soccer_mod/match/halftime.wav")
	es.set("sm_match_sound_match_end", "soccer_mod/match/endmatch.wav")

	es.set("sm_match_rank_goal", 25)
	es.set("sm_match_rank_assist", 10)
	es.set("sm_match_rank_own_goal", -25)
	es.set("sm_match_rank_hit", 1)
	es.set("sm_match_rank_pass", 5)
	es.set("sm_match_rank_interception", 2)

	es.server.cmd("exec soccer_mod/modules/match.cfg")

# ******************** Commands ********************
def cmd_stats(args):
	es.set("sm_cmd_match_stats", args[0])

def stats_save_round_end(args):
	set_boolean("sm_match_stats_save_round_end", args[0])

def match_start(args):
	es.set("sm_cmd_match_start", args[0])

def match_pause(args):
	es.set("sm_cmd_match_pause", args[0])

def match_unpause(args):
	es.set("sm_cmd_match_unpause", args[0])

def match_stop(args):
	es.set("sm_cmd_match_stop", args[0])

def swap_home_away(args):
	set_boolean("sm_match_swap_home_away_on", args[0])

def sound_round_start(args):
	es.set("sm_match_sound_round_start", args[0])

def sound_round_end(args):
	es.set("sm_match_sound_round_end", args[0])

def sound_period_end(args):
	es.set("sm_match_sound_period_end", args[0])

def sound_match_end(args):
	es.set("sm_match_sound_match_end", args[0])

def rank_goal(args):
	set_int("sm_match_rank_goal", args[0], 25)

def rank_assist(args):
	set_int("sm_match_rank_assist", args[0], 10)

def rank_own_goal(args):
	set_int("sm_match_rank_own_goal", args[0], -25)

def rank_hit(args):
	set_int("sm_match_rank_hit", args[0], 1)

def rank_pass(args):
	set_int("sm_match_rank_pass", args[0], 5)

def rank_interception(args):
	set_int("sm_match_rank_interception", args[0], 2)

# ******************** Events ********************
def es_map_start(event_var):
	es.server.cmd("exec soccer_mod/modules/match.cfg")

# ******************** Functions ********************
def set_boolean(name, value):
	try:
		if int(value) == 1:
			es.set(name, 1)
		else:
			es.set(name, 0)
	except ValueError:
		es.set(name, 0)

def set_int(name, value, default):
	try:
		es.set(name, int(value))
	except ValueError:
		es.set(name, default)

# ******************** Unload ********************
def unload():
	commands = [
		"soccer_mod_match_cmd_stats",
		"soccer_mod_match_stats_save_round_end",
		"soccer_mod_match_cmd_start",
		"soccer_mod_match_cmd_pause",
		"soccer_mod_match_cmd_unpause",
		"soccer_mod_match_cmd_stop",
		"soccer_mod_match_swap_home_away",
		"soccer_mod_match_sound_round_start",
		"soccer_mod_match_sound_round_end",
		"soccer_mod_match_sound_period_end",
		"soccer_mod_match_sound_match_end",
		"soccer_mod_match_rank_goal",
		"soccer_mod_match_rank_assist",
		"soccer_mod_match_rank_own_goal",
		"soccer_mod_match_rank_hit",
		"soccer_mod_match_rank_pass",
		"soccer_mod_match_rank_interception"
	]

	for cmd in commands:
		cmdlib.unregisterServerCommand(cmd)