﻿import cmdlib
import es

# ******************** Load ********************
def load():
	cmdlib.registerServerCommand("soccer_mod_shout_cmd", shout, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_delay", delay, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_shout_sound_foul", sound_foul, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_goal", sound_goal, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_ole", sound_ole, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_pass", sound_pass, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_save", sound_save, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_shot", sound_shot, "Server Command")

	es.set("sm_cmd_shout", "!shout")
	es.set("sm_shout_delay", 3)

	es.set("sm_shout_sound_foul", "soccer_mod/shout/rampage.mp3")
	es.set("sm_shout_sound_goal", "soccer_mod/shout/unstoppable.mp3")
	es.set("sm_shout_sound_ole", "soccer_mod/shout/humiliation.mp3")
	es.set("sm_shout_sound_pass", "soccer_mod/shout/teamkiller.mp3")
	es.set("sm_shout_sound_save", "soccer_mod/shout/godlike.mp3")
	es.set("sm_shout_sound_shot", "soccer_mod/shout/holyshit.mp3")

	es.server.cmd("exec soccer_mod/modules/shout.cfg")

# ******************** Commands ********************
def shout(args):
	es.set("sm_cmd_shout", args[0])

def delay(args):
	try:
		check = int(args[0])
		es.set("sm_shout_delay", check)
	except ValueError:
		es.set("sm_shout_delay", 3)

def sound_foul(args):
	es.set("sm_shout_sound_foul", args[0])

def sound_goal(args):
	es.set("sm_shout_sound_goal", args[0])

def sound_ole(args):
	es.set("sm_shout_sound_ole", args[0])

def sound_pass(args):
	es.set("sm_shout_sound_pass", args[0])

def sound_save(args):
	es.set("sm_shout_sound_save", args[0])

def sound_shot(args):
	es.set("sm_shout_sound_shot", args[0])

# ******************** Events ********************
def es_map_start(event_var):
	es.server.cmd("exec soccer_mod/modules/shout.cfg")

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_shout_cmd")

	cmdlib.unregisterServerCommand("soccer_mod_shout_delay")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_foul")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_goal")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_ole")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_pass")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_save")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_shot")