import es
import keyvalues
import os

# ******************** Events ********************
def es_map_start(event_var):
	refresh_downloads()

# ******************** Functions ********************
def refresh_downloads():
	if es.ServerVar("sm_downloads_auto_on") == 1:
		file_name = "cstrike/cfg/soccer_mod/downloads.cfg"
		try:
			os.remove(file_name)
		except OSError:
			error = 1

		global f
		f = open(file_name, "w")

		add_sound("sm_vote_sound_start")

		if es.ServerVar("sm_module_match_on") == 1:
			add_sound("sm_match_sound_round_start")
			add_sound("sm_match_sound_round_end")
			add_sound("sm_match_sound_period_end")
			add_sound("sm_match_sound_match_end")

		if es.ServerVar("sm_module_referee_on") == 1:
			add_sound("sm_referee_sound_whistle")
			add_sound("sm_referee_sound_red_card")

			if es.ServerVar("sm_module_referee_punish_on") == 1:
				add_sound("sm_referee_sound_fireworks")
				add_sound("sm_referee_sound_give_dope")
				add_sound("sm_referee_sound_out_breath")
				add_sound("sm_referee_sound_lightning")
				add_sound("sm_referee_sound_cheer_leader_1")
				add_sound("sm_referee_sound_cheer_leader_2")
				add_sound("sm_referee_sound_cheer_leader_3")

		if es.ServerVar("sm_module_shout_on") == 1:
			add_sound("sm_shout_sound_foul")
			add_sound("sm_shout_sound_goal")
			add_sound("sm_shout_sound_ole")
			add_sound("sm_shout_sound_pass")
			add_sound("sm_shout_sound_save")
			add_sound("sm_shout_sound_shot")

		if es.ServerVar("sm_module_skins_on") == 1:
			add_model(str(es.ServerVar("sm_skins_t")))
			add_model(str(es.ServerVar("sm_skins_ct")))
			add_model(str(es.ServerVar("sm_skins_t_gk")))
			add_model(str(es.ServerVar("sm_skins_ct_gk")))

			skins = keyvalues.getKeyGroup("soccer_mod_skins")
			if skins != None:
				for item in skins:
					value = es.keygetvalue("soccer_mod_skins", item, "t")
					if value != "" and value != es.ServerVar("sm_skins_t") and value != es.ServerVar("sm_skins_ct") and value != es.ServerVar("sm_skins_t_gk") and value != es.ServerVar("sm_skins_ct_gk"):
						add_model(value)

					value = es.keygetvalue("soccer_mod_skins", item, "ct")
					if value != "" and value != es.ServerVar("sm_skins_t") and value != es.ServerVar("sm_skins_ct") and value != es.ServerVar("sm_skins_t_gk") and value != es.ServerVar("sm_skins_ct_gk"):
						add_model(value)

		if es.ServerVar("sm_module_training_on") == 1:
			add_model("models/" + str(es.ServerVar("sm_training_model_ball")))

		f.close()

	if es.ServerVar("soccer_mod_allowed") == 1:
		if int(es.ServerVar("sm_downloads_on")) == 1:
			es.server.cmd("exec soccer_mod/downloads.cfg")

def add_sound(sound):
	global f
	f.write('downloadable "sound/%s"\n' % (es.ServerVar(sound)))

def add_model(value):
	words = value.split("/")

	dir = ""
	for i in range(0, len(words) - 1):
		dir += words[i] + "/"

	add_dir("materials/" + dir)
	add_dir(dir)

def add_dir(dir):
	path = "cstrike/%s" % (dir)
	for item in os.listdir(path):
		if os.path.isdir(path + "/" + item) != True:
			type = item.split(".")
			length = len(type) - 1
			if type[length] != "ztmp" and type[length] != "bz2":
				global f
				f.write('downloadable "%s%s"\n' % (dir, item))