﻿import es
import langlib
import popuplib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/info/popup_info_leagues.ini")

# ******************** Load ********************
def load():
	create_popup_leagues()
	create_popup_leagues_acssl()
	create_popup_leagues_ssl()
	create_popup_leagues_xsl()

# ******************** Create popups ********************
def create_popup_leagues():
	popup = popuplib.create("sm_popup_info_leagues")

	popup.addline(text("title"))
	popup.addline(" ")
	popup.addline("->1. %s" % (text("acssl")))
	popup.addline("->2. %s" % (text("ssl")))
	popup.addline("->3. %s" % (text("xsl")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (common("close")))

	popup.submenu(1, "sm_popup_info_leagues_acssl")
	popup.submenu(2, "sm_popup_info_leagues_ssl")
	popup.submenu(3, "sm_popup_info_leagues_xsl")
	popup.submenu(4, "sm_popup_info_leagues")
	popup.submenu(5, "sm_popup_info_leagues")
	popup.submenu(6, "sm_popup_info_leagues")
	popup.submenu(7, "sm_popup_info_leagues")
	popup.submenu(8, "sm_popup_info_leagues")
	popup.submenu(9, "sm_popup_info")

def create_popup_leagues_acssl():
	popup = popuplib.create("sm_popup_info_leagues_acssl")

	popup.addline(text("title_acssl"))
	popup.addline(" ")
	popup.addline("%s: %s" % (text("location"), text("australia")))
	popup.addline("%s: http://www.acssl.com" % (text("website")))
	popup.addline("%s: http://steamcommunity.com/groups/acssl" % (text("public")))
	popup.addline(" ")
	popup.addline("->1. %s" % (text("open")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (common("close")))

	popup.select(1, open_website)
	popup.submenu(2, "sm_popup_info_leagues_acssl")
	popup.submenu(3, "sm_popup_info_leagues_acssl")
	popup.submenu(4, "sm_popup_info_leagues_acssl")
	popup.submenu(5, "sm_popup_info_leagues_acssl")
	popup.submenu(6, "sm_popup_info_leagues_acssl")
	popup.submenu(7, "sm_popup_info_leagues_acssl")
	popup.submenu(8, "sm_popup_info_leagues_acssl")
	popup.submenu(9, "sm_popup_info_leagues")

def create_popup_leagues_ssl():
	popup = popuplib.create("sm_popup_info_leagues_ssl")

	popup.addline(text("title_ssl"))
	popup.addline(" ")
	popup.addline("%s: %s" % (text("location"), text("north_america")))
	popup.addline("%s: http://www.psl-source.com" % (text("website")))
	popup.addline(" ")
	popup.addline("->1. %s" % (text("open")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (common("close")))

	popup.select(1, open_website)
	popup.submenu(2, "sm_popup_info_leagues_ssl")
	popup.submenu(3, "sm_popup_info_leagues_ssl")
	popup.submenu(4, "sm_popup_info_leagues_ssl")
	popup.submenu(5, "sm_popup_info_leagues_ssl")
	popup.submenu(6, "sm_popup_info_leagues_ssl")
	popup.submenu(7, "sm_popup_info_leagues_ssl")
	popup.submenu(8, "sm_popup_info_leagues_ssl")
	popup.submenu(9, "sm_popup_info_leagues")

def create_popup_leagues_xsl():
	popup = popuplib.create("sm_popup_info_leagues_xsl")

	popup.addline(text("title_xsl"))
	popup.addline(" ")
	popup.addline("%s: %s" % (text("location"), text("europe")))
	popup.addline("%s: http://www.xsleague.com" % (text("website")))
	popup.addline("%s: http://steamcommunity.com/groups/XSL-P" % (text("public")))
	popup.addline("%s: http://steamcommunity.com/groups/XSL" % (text("staff")))
	popup.addline(" ")
	popup.addline("->1. %s" % (text("open")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (common("close")))

	popup.select(1, open_website)
	popup.submenu(2, "sm_popup_info_leagues_xsl")
	popup.submenu(3, "sm_popup_info_leagues_xsl")
	popup.submenu(4, "sm_popup_info_leagues_xsl")
	popup.submenu(5, "sm_popup_info_leagues_xsl")
	popup.submenu(6, "sm_popup_info_leagues_xsl")
	popup.submenu(7, "sm_popup_info_leagues_xsl")
	popup.submenu(8, "sm_popup_info_leagues_xsl")
	popup.submenu(9, "sm_popup_info_leagues")

# ******************** Functions ********************
def open_website(userid, choice, popupname):
	if popupname == "sm_popup_info_leagues_acssl":
		cmd = 'usermsg motd %s 2 "%s" "http://www.acssl.com"' % (userid, text("title_acssl"))
	elif popupname == "sm_popup_info_leagues_ssl":
		cmd = 'usermsg motd %s 2 "%s" "http://www.psl-source.com"' % (userid, text("title_ssl"))
	elif popupname == "sm_popup_info_leagues_xsl":
		cmd = 'usermsg motd %s 2 "%s" "http://www.xsleague.com"' % (userid, text("title_xsl"))

	es.server.queuecmd(cmd)

	popuplib.send(popupname, userid)

def delete_popup(name):
	if popuplib.exists(name):
		popuplib.delete(name)

# ******************** Unload ********************
def unload():
	delete_popup("sm_popup_info_leagues")
	delete_popup("sm_popup_info_leagues_acssl")
	delete_popup("sm_popup_info_leagues_ssl")
	delete_popup("sm_popup_info_leagues_xsl")