﻿import es
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_admin_match_names")

texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/popup_admin_match_names.ini")
text_score = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/popup_admin_match_score.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/messages_match_names.ini")

# ******************** Load ********************
def load():
	load_variables()
	create_popup()
	es.addons.registerSayFilter(sayFilter)

# ******************** Load variables ********************
def load_variables():
	es.set("sm_match_name_t", es.ServerVar("sm_match_default_name_t"))
	es.set("sm_match_name_ct", es.ServerVar("sm_match_default_name_ct"))
	es.set("sm_match_name_t_abbr", es.ServerVar("sm_match_default_name_t_abbr"))
	es.set("sm_match_name_ct_abbr", es.ServerVar("sm_match_default_name_ct_abbr"))

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")

	popup.addline("SOCCER MOD %s" % (texts("title")))
	popup.addline(" ")
	popup.addline("->1. %s: %s" % (texts("name_t"), es.ServerVar("sm_match_name_t")))
	popup.addline("->2. %s: %s" % (texts("name_ct"), es.ServerVar("sm_match_name_ct")))
	popup.addline("->3. %s: %s" % (texts("short_name_t"), es.ServerVar("sm_match_name_t_abbr")))
	popup.addline("->4. %s: %s" % (texts("short_name_ct"), es.ServerVar("sm_match_name_ct_abbr")))
	popup.addline("->5. %s" % (texts("reset")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, change_name)
	popup.select(2, change_name)
	popup.select(3, change_name)
	popup.select(4, change_name)
	popup.select(5, reset_names)
	popup.submenu(6, "sm_popup_admin_match_names")
	popup.submenu(7, "sm_popup_admin_match_names")
	popup.submenu(8, "sm_popup_admin_match_names")
	popup.submenu(9, "sm_popup_admin_match")

# ******************** Popup choices ********************
def change_name(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
		es.keycreate("sm_keygroup_set", player.steamid)

	if choice == 1:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "match_name_t")
		es.tell(userid, "#green", messages("set_t_message", tokens, player.get("lang")))
	elif choice == 2:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "match_name_ct")
		es.tell(userid, "#green", messages("set_ct_message", tokens, player.get("lang")))
	elif choice == 3:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "match_name_t_abbr")
		es.tell(userid, "#green", messages("set_short_t_message", tokens, player.get("lang")))
	elif choice == 4:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "match_name_ct_abbr")
		es.tell(userid, "#green", messages("set_short_ct_message", tokens, player.get("lang")))

def reset_names(userid, choice, popupid):
	name = es.ServerVar("sm_match_default_name_t")
	popup.modline(3, "->1. %s: %s" % (texts("name_t"), name))
	es.set("sm_match_name_t", name)

	tokens = {}
	tokens["team"] = name
	popuplib.find("sm_popup_admin_match_score").modline(3, "->1. %s" % (text_score("add", tokens)))

	tokens["team"] = name
	popuplib.find("sm_popup_admin_match_score").modline(4, "->2. %s" % (text_score("remove", tokens)))

	name = es.ServerVar("sm_match_default_name_ct")
	popup.modline(4, "->2. %s: %s" % (texts("name_ct"), name))
	es.set("sm_match_name_ct", name)

	tokens["team"] = name
	popuplib.find("sm_popup_admin_match_score").modline(5, "->3. %s" % (text_score("add", tokens)))

	tokens["team"] = name
	popuplib.find("sm_popup_admin_match_score").modline(6, "->4. %s" % (text_score("remove", tokens)))

	name = es.ServerVar("sm_match_default_name_t_abbr")
	popup.modline(5, "->3. %s: %s" % (texts("short_name_t"), name))
	es.set("sm_match_name_t_abbr", name)

	name = es.ServerVar("sm_match_default_name_ct_abbr")
	popup.modline(6, "->4. %s: %s" % (texts("short_name_ct"), name))
	es.set("sm_match_name_ct_abbr", name)

	tokens["name"] = es.getplayername(userid)
	lang_msg("reset", tokens)

	popuplib.send("sm_popup_admin_match_names", userid)

# ******************** Events ********************
def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "match_name_t":
			set_value(text, userid, 25, "sm_match_name_t", 1, "name_t", "set_t")
			return (0, None, 0)
		elif type == "match_name_ct":
			set_value(text, userid, 25, "sm_match_name_ct", 2, "name_ct", "set_ct")
			return (0, None, 0)
		elif type == "match_name_t_abbr":
			set_value(text, userid, 5, "sm_match_name_t_abbr", 3, "short_name_t", "set_short_t")
			return (0, None, 0)
		elif type == "match_name_ct_abbr":
			set_value(text, userid, 5, "sm_match_name_ct_abbr", 4, "short_name_ct", "set_short_ct")
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def set_value(text, userid, max, cvar, number, popup_text, lang):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if text != "!cancel":
		if len(text) <= max:
			es.set(cvar, text)

			popup.modline((number + 2), "->%s. %s: %s" % (number, texts(popup_text), text))

			tokens["name"] = player.name
			tokens["value"] = text
			lang_msg(lang, tokens)

			clear_key(userid, player.steamid)
		else:
			tokens["number"] = max
			es.tell(userid, "#green", messages("to_long", tokens, player.get("lang")))
	else:
		clear_key(userid, player.steamid)

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_match_names", userid)

# ******************** Unload ********************
def unload():
	es.addons.unregisterSayFilter(sayFilter)
	popuplib.delete("sm_popup_admin_match_names")