﻿import es
import langlib
import playerlib
import popuplib

messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/messages_match_score.ini")

# ******************** Load ********************
def load():
	create_popup()
	load_variables()

# ******************** Load variables ********************
def load_variables():
	es.set("sm_match_score_t", 0)
	es.set("sm_match_score_ct", 0)

# ******************** Events ********************
def es_map_start(event_var):
	load_variables()

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		es.server.queuecmd("score set #t %s" % (es.ServerVar("sm_match_score_t")))
		es.server.queuecmd("score set #ct %s" % (es.ServerVar("sm_match_score_ct")))

def round_end(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		tokens = {}

		winner = int(event_var["winner"])

		name_t = es.ServerVar("sm_match_name_t")
		name_ct = es.ServerVar("sm_match_name_ct")

		name_t_abbr = es.ServerVar("sm_match_name_t_abbr")
		name_ct_abbr = es.ServerVar("sm_match_name_ct_abbr")

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		swap = int(es.ServerVar("sm_match_swap_home_away_on"))
		seconds = es.ServerVar("sm_match_seconds")
		minutes = es.ServerVar("sm_match_minutes")

		if winner == 1:
			check = es.ServerVar("match")
			if check == 0:
				load_variables()

		if winner == 2:
			score_t += 1
			es.set("sm_match_score_t", score_t)

			tokens["team"] = name_t

		if winner == 3:
			score_ct += 1
			es.set("sm_match_score_ct", score_ct)

			tokens["team"] = name_ct

		if int(es.ServerVar("sm_match_goal_scored")) == 1:
			if winner > 1:
				if es.ServerVar("match") == 1:
					if swap == 0:
						score = ": %s %s - %s %s." % (name_t_abbr, score_t, score_ct, name_ct_abbr)
						if seconds < 10:
							tokens["time"] = "%s:0%s" % (minutes, seconds)
						else:
							tokens["time"] = "%s:%s" % (minutes, seconds)
					else:
						score = ": %s %s - %s %s." % (name_ct_abbr, score_ct, score_t, name_t_abbr)
						if seconds < 10:
							tokens["time"] = "%s:0%s" % (minutes, seconds)
						else:
							tokens["time"] = "%s:%s" % (minutes, seconds)

					message = messages("match_goal_scored", tokens) + score
				else:
					if swap == 0:
						score = ": %s %s - %s %s." % (name_t_abbr, score_t, score_ct, name_ct_abbr)
					else:
						score = ": %s %s - %s %s." % (name_ct_abbr, score_ct, score_t, name_t_abbr)
					message = messages("goal_scored", tokens) + score

				es.msg("#green", message)

		if es.ServerVar("golden_goal") == 1:
			if winner == 2:
				es.doblock("soccer_mod_2010/match/end/win_t")
			if winner == 3:
				es.doblock("soccer_mod_2010/match/end/win_ct")

			es.set("match", 0)
			es.set("match_paused", 0)
			es.set("period_running", 0)
			es.set("period_break_running", 0)
			es.set("golden_goal", 0)
			es.set("seconds", 0)
			es.set("minutes", 0)
			es.set("period_break_running", 0)

		es.server.queuecmd("score set #t %s" % (score_t))
		es.server.queuecmd("score set #ct %s" % (score_ct))

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/popup_admin_match_score.ini")

	popup = popuplib.create("sm_popup_admin_match_score")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")

	tokens = {}

	tokens["team"] = es.ServerVar("sm_match_name_t")
	popup.addline("->1. %s" % (text("add", tokens)))

	tokens["team"] = es.ServerVar("sm_match_name_t")
	popup.addline("->2. %s" % (text("remove", tokens)))

	tokens["team"] = es.ServerVar("sm_match_name_ct")
	popup.addline("->3. %s" % (text("add", tokens)))

	tokens["team"] = es.ServerVar("sm_match_name_ct")
	popup.addline("->4. %s" % (text("remove", tokens)))

	popup.addline("->5. %s" % (text("reset")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, add_t)
	popup.select(2, remove_t)
	popup.select(3, add_ct)
	popup.select(4, remove_ct)
	popup.select(5, reset_score)
	popup.submenu(6, "sm_popup_admin_match_score")
	popup.submenu(7, "sm_popup_admin_match_score")
	popup.submenu(8, "sm_popup_admin_match_score")
	popup.submenu(9, "sm_popup_admin_match")

# ******************** Popup choices ********************
def add_t(userid, choice, popupid):
	score = es.ServerVar("sm_match_score_t")
	score += 1
	es.set("sm_match_score_t", score)

	es.server.queuecmd("score set #t %s" % (score))

	tokens = {}
	tokens["name"] = es.getplayername(userid)
	tokens["team"] = es.ServerVar("sm_match_name_t")
	lang_msg("goal_added", tokens)

	popuplib.send("sm_popup_admin_match_score", userid)

def remove_t(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	score = es.ServerVar("sm_match_score_t")
	if score > 0:
		score -= 1
		es.set("sm_match_score_t", score)

		es.server.queuecmd("score set #t %s" % (score))

		tokens["name"] = es.getplayername(userid)
		tokens["team"] = es.ServerVar("sm_match_name_t")
		lang_msg("goal_removed", tokens)
	else:
		es.tell(userid, "#green", messages("already_0", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_match_score", userid)

def add_ct(userid, choice, popupid):
	score = es.ServerVar("sm_match_score_ct")
	score += 1
	es.set("sm_match_score_ct", score)

	es.server.queuecmd("score set #ct %s" % (score))

	tokens = {}
	tokens["name"] = es.getplayername(userid)
	tokens["team"] = es.ServerVar("sm_match_name_ct")
	lang_msg("goal_added", tokens)

	popuplib.send("sm_popup_admin_match_score", userid)

def remove_ct(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	score = es.ServerVar("sm_match_score_ct")
	if score > 0:
		score -= 1
		es.set("sm_match_score_ct", score)

		es.server.queuecmd("score set #ct %s" % (score))

		tokens["name"] = es.getplayername(userid)
		tokens["team"] = es.ServerVar("sm_match_name_ct")
		lang_msg("goal_removed", tokens)
	else:
		es.tell(userid, "#green", messages("already_0", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_match_score", userid)

def reset_score(userid, choice, popupid):
	load_variables()

	es.server.queuecmd("score set #t 0")
	es.server.queuecmd("score set #ct 0")

	tokens = {}
	tokens["name"] = es.getplayername(userid)
	lang_msg("reset", tokens)

	popuplib.send("sm_popup_admin_match_score", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def delete_popup():
	if popuplib.exists("sm_popup_admin_match_score"):
		popuplib.delete("sm_popup_admin_match_score")

# ******************** Unload ********************
def unload():
	delete_popup()