﻿import es
import gamethread
import playerlib
import random
from spe.games import cstrike

hurt_sounds = [
	"vo/npc/barney/ba_ohshit03.wav",
	"vo/npc/barney/ba_pain01.wav",
	"vo/npc/barney/ba_pain02.wav",
	"vo/npc/barney/ba_pain03.wav",
	"vo/npc/barney/ba_pain04.wav",
	"vo/npc/barney/ba_pain05.wav",
	"vo/npc/barney/ba_pain06.wav",
	"vo/npc/barney/ba_pain07.wav",
	"vo/npc/barney/ba_pain08.wav",
	"vo/npc/barney/ba_pain09.wav",
	"vo/npc/barney/ba_pain10.wav",
	"vo/npc/male01/pain01.wav",
	"vo/npc/male01/pain02.wav",
	"vo/npc/male01/pain03.wav",
	"vo/npc/male01/pain04.wav",
	"vo/npc/male01/pain05.wav",
	"vo/npc/male01/pain06.wav",
	"vo/npc/male01/pain07.wav",
	"vo/npc/male01/pain08.wav",
	"vo/npc/male01/pain09.wav",
	"vo/npc/male01/ow01.wav"
]

# ******************** Load ********************
def load():
	global round_end
	round_end = 0

# ******************** Events ********************
def player_death(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_player_respawn_enabled") == 1:
			gamethread.delayed(es.ServerVar("sm_player_respawn_length"), respawn, (event_var["userid"]))

def player_hurt(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("cap_fight") == 0:
			if es.ServerVar("sm_player_god_mode_on") == 0:
				player = playerlib.getPlayer(event_var["userid"])
				player.health = 250

		if es.ServerVar("sm_player_hurt_sounds_on") == 1:
			sound = random.randint(0, (len(hurt_sounds) - 1))
			es.emitsound("player", event_var["userid"], hurt_sounds[sound], "1.0", "1.0")

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		player = playerlib.getPlayer(event_var["userid"])
		if player.team > 1:
			if es.ServerVar("cap_fight") == 0:
				player.health = 250

				if es.ServerVar("sm_player_god_mode_on") == 1:
					player.godmode(1)

def player_team(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_player_respawn_enabled") == 1:
			gamethread.delayed(es.ServerVar("sm_player_respawn_length"), respawn, (event_var["userid"]))

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		global round_end
		round_end = 0

		players = es.getUseridList()
		length = len(players)
		if length > 0:
			length -= 1

			cmd = 'es_xfire %s trigger_hurt addoutput "OnStartTouch point_servercommand,command,es_xdoblock soccer_mod_2010/player/disable_god_mode"' % (players[random.randint(0, length)])
			es.server.queuecmd(cmd)

def round_end(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		global round_end
		round_end = 1

# ******************** Functions ********************
def disable_god_mode():
	for ply in playerlib.getPlayerList("#alive"):
		ply.godmode(0)

def respawn(userid):
	if es.exists("userid", userid) == 1:
		global round_end
		player = playerlib.getPlayer(userid)
		if player.isdead == 1 and player.team > 1 and round_end == 0:
				cstrike.respawn(userid)