﻿import es
import gamethread
import langlib
import playerlib
import popuplib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/referee/messages_referee_warn.ini")

# ******************** Load ********************
def load():
	create_popup()

	es.addons.registerSayFilter(sayFilter)

# ******************** Events ********************
def es_map_start(event_var):
	popuplib.delete("sm_popup_admin_referee_warn")
	create_popup()

def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "referee_custom_warning":
			if text != "!cancel":
				warning(userid, es.keygetvalue("sm_keygroup_set", steamid, "userid"), text)
			else:
				popuplib.send("sm_popup_admin_referee_warn", userid)

			es.keydelete("sm_keygroup_set", steamid)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/referee/popup_admin_referee_warn.ini")

	popup = popuplib.create("sm_popup_admin_referee_warn")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")

	tokens = {}
	for i in range(1, 8):
		tokens["warning"] = es.ServerVar("sm_referee_warning_%s" % (i))
		popup.addline("->%s. %s" % (i, text("warning", tokens)))

	popup.addline("->8. %s" % (text("custom")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, select_warning)
	popup.select(2, select_warning)
	popup.select(3, select_warning)
	popup.select(4, select_warning)
	popup.select(5, select_warning)
	popup.select(6, select_warning)
	popup.select(7, select_warning)
	popup.select(8, select_warning)
	popup.submenu(9, "sm_popup_admin_referee")

# ******************** Popup choices ********************
def select_warning(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	if choice == 1:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_1")
	elif choice == 2:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_2")
	elif choice == 3:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_3")
	elif choice == 4:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_4")
	elif choice == 5:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_5")
	elif choice == 6:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_6")
	elif choice == 7:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "warning_7")
	elif choice == 8:
		create_player_menu(name, messages("select_player"), "#human", "sm_popup_admin_referee_warn", "custom_warning")

	popuplib.send(name, userid)

# ******************** Player menu choices ********************
def choice(userid, choice, keymenuname):
	type = choice.split("_")
	if type[0] == "warning":
		warning(userid, type[2], es.ServerVar("sm_referee_warning_%s" %(type[1])))
	elif type[0] == "custom":
		tokens = {}
		player = playerlib.getPlayer(userid)

		name = "sm_popup_%s" % (userid)
		if popuplib.exists(name):
			popuplib.delete(name)

		if es.exists("userid", type[2]) == 1:
			if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
				es.keycreate("sm_keygroup_set", player.steamid)

			es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "referee_custom_warning")
			es.keysetvalue("sm_keygroup_set", player.steamid, "userid", type[2])

			es.tell(userid, "#green", messages("set_warning", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages("no_player_found", tokens, player.get("lang")))
			popuplib.send("sm_popup_admin_referee_warn", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def warning(userid, choice, warn):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	if es.exists("userid", choice) == 1:
		target = playerlib.getPlayer(choice)

		es.cexec_all("playgamesound", es.ServerVar("sm_referee_sound_whistle"))

		tokens["name"] = player.name
		tokens["target"] = target.name
		tokens["warning"] = warn
		lang_msg("warn_message", tokens)

		es.menu(5, int(choice), messages("warning", tokens, target.get("lang")))

		es.centertell(choice, messages("warning", tokens, target.get("lang")))
		gamethread.delayed(1, es.centertell, (choice, messages("warning", tokens, target.get("lang"))))
		gamethread.delayed(2, es.centertell, (choice, messages("warning", tokens, target.get("lang"))))
		gamethread.delayed(3, es.centertell, (choice, messages("warning", tokens, target.get("lang"))))
		gamethread.delayed(4, es.centertell, (choice, messages("warning", tokens, target.get("lang"))))
	else:
		es.tell(userid, "#green", messages("no_player_found", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_referee_warn", userid)

def create_player_menu(name, title, users, cancelmenu, type):
	myPopup = popuplib.easymenu(name, None, choice)
	myPopup.settitle(title)

	for player in playerlib.getPlayerList(users):
		myPopup.addoption("%s_%s" % (type, player.userid), player.name)

	myPopup.submenu(10, cancelmenu)

# ******************** Unload ********************
def unload():
	es.addons.unregisterSayFilter(sayFilter)

	popuplib.delete("sm_popup_admin_referee_warn")