﻿import es
import langlib
import playerlib
import popuplib
import re

popup = popuplib.create("sm_popup_admin_settings_cap")

texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_cap.ini")
text_cap = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/popup_admin_cap_fights.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_cap.ini")

# ******************** Load ********************
def load():
	es.set("sm_cap_weapon_1", es.keygetvalue("soccer_mod_settings", "cap", "weapon_1"))
	es.set("sm_cap_weapon_2", es.keygetvalue("soccer_mod_settings", "cap", "weapon_2"))
	es.set("sm_cap_weapon_3", es.keygetvalue("soccer_mod_settings", "cap", "weapon_3"))

	create_popup()

	es.addons.registerSayFilter(sayFilter)

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")

	popup.addline("SOCCER MOD %s" % (texts("title")))
	popup.addline(" ")
	popup.addline("->1. %s #1: %s" % (texts("weapon"), es.ServerVar("sm_cap_weapon_1")))
	popup.addline("->2. %s #2: %s" % (texts("weapon"), es.ServerVar("sm_cap_weapon_2")))
	popup.addline("->3. %s #3: %s" % (texts("weapon"), es.ServerVar("sm_cap_weapon_3")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, weapon)
	popup.select(2, weapon)
	popup.select(3, weapon)
	popup.submenu(4, "sm_popup_admin_settings_cap")
	popup.submenu(5, "sm_popup_admin_settings_cap")
	popup.submenu(6, "sm_popup_admin_settings_cap")
	popup.submenu(7, "sm_popup_admin_settings_cap")
	popup.submenu(8, "sm_popup_admin_settings_cap")
	popup.submenu(9, "sm_popup_admin_settings")

# ******************** Popup choices ********************
def weapon(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
		es.keycreate("sm_keygroup_set", player.steamid)

	es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_cap_weapon_%s" % (choice))

	es.tell(userid, "#green", messages("set_weapon_message", tokens, player.get("lang")))

# ******************** Events ********************
def sayFilter(userid, text, teamonly):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", "sm_keygroup_set", player.steamid) == 1:
		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", player.steamid, "setting_type")
		type_split = type.split("_")
		if type_split[0] == "settings" and type_split[1] == "cap" and type_split[2] == "weapon":
			number = int(type_split[3])
			if number > 0 and number < 4:
				if text != "!cancel":
					check = re.search(".%s" % (text), ".ak47,aug,awp,deagle,elite,fiveseven,g3sg1,galil,glock,m249,m3,m4a1,mac10,mp5navy,p90,p228,scout,sg550,sg552,tmp,ump45,xm1014")
					if check != None:
						es.set("sm_cap_weapon_%s" % (number), text)

						tokens["weapon"] = text
						tokens["name"] = player.name
						tokens["number"] = number

						popup.modline((number + 2), "->%s. %s #%s: %s" % (number, texts("weapon"), number, text))

						popuplib.find("sm_popup_admin_cap_fights").modline((number + 4), "->%s. %s" % (number, text_cap("weapon", tokens)))

						lang_msg("set_weapon", tokens)

						es.keysetvalue("soccer_mod_settings", "cap", "weapon_%s" % (number), text)
						es.keygroupsave("soccer_mod_settings", "soccer_mod")

						clear_key(userid, player.steamid)
					else:
						es.tell(userid, "#green", messages("invalid_weapon", tokens, player.get("lang")))
				else:
					clear_key(userid, player.steamid)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_settings_cap", userid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_cap")
	es.addons.unregisterSayFilter(sayFilter)