﻿import es
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_match_main")

text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_match_main.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_match_main.ini")

# ******************** Load ********************
def load():
	es.set("sm_match_say_command_start_match_on", int(es.keygetvalue("soccer_mod_settings", "match", "public_start_match")))
	es.set("sm_match_say_command_pause_match_on", int(es.keygetvalue("soccer_mod_settings", "match", "public_pause_match")))
	es.set("sm_match_say_command_stop_match_on", int(es.keygetvalue("soccer_mod_settings", "match", "public_stop_match")))
	es.set("sm_match_ready_vote_on", int(es.keygetvalue("soccer_mod_settings", "match", "ready_vote")))
	es.set("sm_match_sounds_on", int(es.keygetvalue("soccer_mod_settings", "match", "match_sounds")))
	es.set("sm_match_score_board_on", int(es.keygetvalue("soccer_mod_settings", "match", "score_board")))
	es.set("sm_match_golden_goal_on", int(es.keygetvalue("soccer_mod_settings", "match", "golden_goal")))

	create_popup()

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")

	add_line("sm_match_say_command_start_match_on", 1, "start_match")
	add_line("sm_match_say_command_pause_match_on", 2, "pause_match")
	add_line("sm_match_say_command_stop_match_on", 3, "stop_match")
	add_line("sm_match_ready_vote_on", 4, "ready_vote")
	add_line("sm_match_sounds_on", 5, "sounds")
	add_line("sm_match_score_board_on", 6, "score_board")
	add_line("sm_match_golden_goal_on", 7, "golden_goal")

	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, change_setting)
	popup.select(2, change_setting)
	popup.select(3, change_setting)
	popup.select(4, change_setting)
	popup.select(5, change_setting)
	popup.select(6, change_setting)
	popup.select(7, change_setting)
	popup.submenu(8, "sm_popup_admin_settings_match_main")
	popup.submenu(9, "sm_popup_admin_settings_match")

def add_line(cvar, number, lang):
	if es.ServerVar(cvar) == 1:
		value = text("on")
	else:
		value = text("off")

	popup.addline("->%s. %s: %s" % (number, text(lang), value))

# ******************** Popup choices ********************
def change_setting(userid, choice, popupid):
	if choice == 1:
		set_value(userid, "sm_match_say_command_start_match_on", "public_start_match", "start_match", "set_public_start", choice)
	elif choice == 2:
		set_value(userid, "sm_match_say_command_pause_match_on", "public_pause_match", "pause_match", "set_public_pause", choice)
	elif choice == 3:
		set_value(userid, "sm_match_say_command_stop_match_on", "public_stop_match", "stop_match", "set_public_stop", choice)
	elif choice == 4:
		set_value(userid, "sm_match_ready_vote_on", "ready_vote", "ready_vote", "set_ready_vote", choice)
	elif choice == 5:
		set_value(userid, "sm_match_sounds_on", "match_sounds", "sounds", "set_match_sounds", choice)
	elif choice == 6:
		set_value(userid, "sm_match_score_board_on", "score_board", "score_board", "set_score_board", choice)
	elif choice == 7:
		set_value(userid, "sm_match_golden_goal_on", "golden_goal", "golden_goal", "set_golden_goal", choice)

# ******************** Functions ********************
def lang_msg_on_off(text, tokens, on_off):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		tokens["value"] = messages(on_off, tokens, player.get("lang"))
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def set_value(userid, cvar, keyvalue, line, msg, number):
	tokens = {}
	tokens["name"] = es.getplayername(userid)

	value = es.ServerVar(cvar)
	if value == 1:
		es.set(cvar, 0)
		es.keysetvalue("soccer_mod_settings", "match", keyvalue, 0)

		popup.modline((number + 2), "->%s. %s: %s" % (number, text(line), text("off")))

		lang_msg_on_off(msg, tokens, "off")
	else:
		es.set(cvar, 1)
		es.keysetvalue("soccer_mod_settings", "match", keyvalue, 1)

		popup.modline((number + 2), "->%s. %s: %s" % (number, text(line), text("on")))

		lang_msg_on_off(msg, tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_match_main")