﻿import es
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_match_names")

texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_match_names.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_match_names.ini")

# ******************** Load ********************
def load():
	es.set("sm_match_default_name_t", es.keygetvalue("soccer_mod_settings", "match", "default_name_t"))
	es.set("sm_match_default_name_ct", es.keygetvalue("soccer_mod_settings", "match", "default_name_ct"))
	es.set("sm_match_default_name_t_abbr", es.keygetvalue("soccer_mod_settings", "match", "default_name_t_abbr"))
	es.set("sm_match_default_name_ct_abbr", es.keygetvalue("soccer_mod_settings", "match", "default_name_ct_abbr"))

	create_popup()

	es.addons.registerSayFilter(sayFilter)

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")

	popup.addline("SOCCER MOD %s" % (texts("title")))
	popup.addline(" ")
	popup.addline("->1. %s: %s" % (texts("name_t"), es.ServerVar("sm_match_default_name_t")))
	popup.addline("->2. %s: %s" % (texts("name_ct"), es.ServerVar("sm_match_default_name_ct")))
	popup.addline("->3. %s: %s" % (texts("short_name_t"), es.ServerVar("sm_match_default_name_t_abbr")))
	popup.addline("->4. %s: %s" % (texts("short_name_ct"), es.ServerVar("sm_match_default_name_ct_abbr")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, change_name)
	popup.select(2, change_name)
	popup.select(3, change_name)
	popup.select(4, change_name)
	popup.submenu(5, "sm_popup_admin_settings_match_names")
	popup.submenu(6, "sm_popup_admin_settings_match_names")
	popup.submenu(7, "sm_popup_admin_settings_match_names")
	popup.submenu(8, "sm_popup_admin_settings_match_names")
	popup.submenu(9, "sm_popup_admin_settings_match")

# ******************** Popup choices ********************
def change_name(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
		es.keycreate("sm_keygroup_set", player.steamid)

	if choice == 1:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_match_name_t")
		es.tell(userid, "#green", messages("set_t_message", tokens, player.get("lang")))
	elif choice == 2:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_match_name_ct")
		es.tell(userid, "#green", messages("set_ct_message", tokens, player.get("lang")))
	elif choice == 3:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_match_name_t_abbr")
		es.tell(userid, "#green", messages("set_short_t_message", tokens, player.get("lang")))
	elif choice == 4:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_match_name_ct_abbr")
		es.tell(userid, "#green", messages("set_short_ct_message", tokens, player.get("lang")))

# ******************** Events ********************
def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_match_name_t":
			set_value(text, userid, 25, "sm_match_default_name_t", 1, "name_t", "default_name_t", "set_t")
			return (0, None, 0)
		elif type == "settings_match_name_ct":
			set_value(text, userid, 25, "sm_match_default_name_ct", 2, "name_ct", "default_name_ct", "set_ct")
			return (0, None, 0)
		elif type == "settings_match_name_t_abbr":
			set_value(text, userid, 5, "sm_match_default_name_t_abbr", 3, "short_name_t", "default_name_t_abbr", "set_short_t")
			return (0, None, 0)
		elif type == "settings_match_name_ct_abbr":
			set_value(text, userid, 5, "sm_match_default_name_ct_abbr", 4, "short_name_ct", "default_name_ct_abbr", "set_short_ct")
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def set_value(text, userid, max, cvar, number, popup_text, keyvalue, lang):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if text != "!cancel":
		length = len(text)
		if length <= max:
			es.set(cvar, text)

			popup.modline((number + 2), "->%s. %s: %s" % (number, texts(popup_text), text))

			es.keysetvalue("soccer_mod_settings", "match", keyvalue, text)
			es.keygroupsave("soccer_mod_settings", "soccer_mod")

			tokens["name"] = player.name
			tokens["value"] = text
			lang_msg(lang, tokens)

			clear_key(userid, player.steamid)
		else:
			tokens["number"] = max
			es.tell(userid, "#green", messages("to_long", tokens, player.get("lang")))
	else:
		clear_key(userid, player.steamid)

def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_settings_match_names", userid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_match_names")
	es.addons.unregisterSayFilter(sayFilter)