﻿import es
import langlib
import popuplib

# ******************** Load ********************
def load():
	es.keygroupload("soccer_mod_settings", "soccer_mod")

	create_popup()

	if es.ServerVar("sm_module_cap_on") == 1:
		es.load("soccer_mod_2010/settings/cap")

	if es.ServerVar("sm_module_match_on") == 1:
		es.load("soccer_mod_2010/settings/match")

	if es.ServerVar("sm_module_player_on") == 1:
		es.load("soccer_mod_2010/settings/player")

	if es.ServerVar("sm_module_skins_on") == 1:
		es.load("soccer_mod_2010/settings/skins")

	if es.ServerVar("sm_module_sprint_on") == 1:
		es.load("soccer_mod_2010/settings/sprint")

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings.ini")

	popup = popuplib.create("sm_popup_admin_settings")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")

	number = 0

	if es.ServerVar("sm_module_cap_on") == 1:
		number += 1
		popup.addline("->%s. %s" % (number, text("cap")))
		popup.submenu(number, "sm_popup_admin_settings_cap")

	if es.ServerVar("sm_module_match_on") == 1:
		number += 1
		popup.addline("->%s. %s" % (number, text("match")))
		popup.submenu(number, "sm_popup_admin_settings_match")

	if es.ServerVar("sm_module_player_on") == 1:
		number += 1
		popup.addline("->%s. %s" % (number, text("player")))
		popup.submenu(number, "sm_popup_admin_settings_player")

	if es.ServerVar("sm_module_skins_on") == 1:
		number += 1
		popup.addline("->%s. %s" % (number, text("skins")))
		popup.submenu(number, "sm_popup_admin_settings_skins")

	if es.ServerVar("sm_module_sprint_on") == 1:
		number += 1
		popup.addline("->%s. %s" % (number, text("sprint")))
		popup.submenu(number, "sm_popup_admin_settings_sprint")

	if number == 0:
		popup.addline(text("none"))

	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	number += 1
	while number < 9:
		popup.submenu(number, "sm_popup_admin_settings")
		number += 1

	popup.submenu(9, "sm_popup_admin")

# ******************** Unload ********************
def unload():
	es.keygroupdelete("soccer_mod_settings")

	popuplib.delete("sm_popup_admin_settings")

	if es.ServerVar("sm_module_cap_on") == 1:
		es.unload("soccer_mod_2010/settings/cap")

	if es.ServerVar("sm_module_match_on") == 1:
		es.unload("soccer_mod_2010/settings/match")

	if es.ServerVar("sm_module_player_on") == 1:
		es.unload("soccer_mod_2010/settings/player")

	if es.ServerVar("sm_module_skins_on") == 1:
		es.unload("soccer_mod_2010/settings/skins")

	if es.ServerVar("sm_module_sprint_on") == 1:
		es.unload("soccer_mod_2010/settings/sprint")