﻿import es
import langlib
import os
import playerlib
import popuplib

skins_folder = "cstrike/models/player"

popup = popuplib.create("sm_popup_admin_settings_skins")

texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_skins.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_skins.ini")

# ******************** Load ********************
def load():
	es.set("sm_skins_default_t", es.keygetvalue("soccer_mod_settings", "skins", "model_t"))
	es.set("sm_skins_default_ct", es.keygetvalue("soccer_mod_settings", "skins", "model_ct"))
	es.set("sm_skins_default_t_gk", es.keygetvalue("soccer_mod_settings", "skins", "model_t_gk"))
	es.set("sm_skins_default_ct_gk", es.keygetvalue("soccer_mod_settings", "skins", "model_ct_gk"))

	create_popup()

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")

	popup.addline("SOCCER MOD %s" % (texts("title")))
	popup.addline(" ")

	value = str(es.ServerVar("sm_skins_default_t"))
	popup.addline("->1. %s: %s" % (texts("t"), value[14:len(value)]))

	value = str(es.ServerVar("sm_skins_default_ct"))
	popup.addline("->2. %s: %s" % (texts("ct"), value[14:len(value)]))

	value = str(es.ServerVar("sm_skins_default_t_gk"))
	popup.addline("->3. %s: %s" % (texts("t_gk"), value[14:len(value)]))

	value = str(es.ServerVar("sm_skins_default_ct_gk"))
	popup.addline("->4. %s: %s" % (texts("ct_gk"), value[14:len(value)]))

	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, choose_skin)
	popup.select(2, choose_skin)
	popup.select(3, choose_skin)
	popup.select(4, choose_skin)
	popup.submenu(5, "sm_popup_admin_settings_skins")
	popup.submenu(6, "sm_popup_admin_settings_skins")
	popup.submenu(7, "sm_popup_admin_settings_skins")
	popup.submenu(8, "sm_popup_admin_settings_skins")
	popup.submenu(9, "sm_popup_admin_settings")

# ******************** Popup choices ********************
def choose_skin(userid, choice, popupid):
	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	value = str(skins_folder)
	if choice == 1:
		open_path(popup_name, value, "tp")
	elif choice == 2:
		open_path(popup_name, value, "cp")
	elif choice == 3:
		open_path(popup_name, value, "tg")
	elif choice == 4:
		open_path(popup_name, value, "cg")

	popuplib.send(popup_name, userid)

# ******************** Functions ********************
def open_path(popup_name, path, team):
	myPopup = popuplib.easymenu(popup_name, None, choice)
	myPopup.settitle(texts("select"))

	dirup = path.split("/")

	length = len(dirup) - 1
	dir = ""
	for i in range(0, length):
		if i < (length - 1):
			dir += dirup[i] + "/"
		else:
			dir += dirup[i]

	value = str(skins_folder)
	if path != value:
		myPopup.addoption("dir_" + team + "_" + dir, "^ " + texts("up") + " ^")

	list = os.listdir(path)
	list.sort()
	for item in list:
		if os.path.isdir(path + "/" + item) == True:
			myPopup.addoption("dir_" + team + "_" + path + "/" + item, "(" + texts("folder") + ") " + item)

	list = os.listdir(path)
	list.sort()
	for item in list:
		if os.path.isdir(path + "/" + item) == False:
			type = item.split(".")
			length = len(type) - 1
			if type[length] == "mdl":
				myPopup.addoption("file_" + team + "_" + path + "/" + item, item)

	myPopup.submenu(10, "sm_popup_admin_settings_skins")

def choice(userid, choice, keymenuname):
	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	length = len(choice)

	type = choice.split("_")
	if type[0] == "dir":
		path = choice[7:length]
		open_path(popup_name, path, type[1])
		popuplib.send(popup_name, userid)
	else:
		player = playerlib.getPlayer(userid)
		value = choice[16:length]

		tokens = {}
		tokens["name"] = player.name
		tokens["value"] = value[14:len(value)]

		if type[1] == "tp":
			es.set("sm_skins_default_t", value)
			es.keysetvalue("soccer_mod_settings", "skins", "model_t", value)

			line = "->1. %s: %s" % (texts("t"), value[14:len(value)])
			popup.modline(3, line)

			lang_msg("t", tokens)
		elif type[1] == "cp":
			es.set("sm_skins_default_ct", value)
			es.keysetvalue("soccer_mod_settings", "skins", "model_ct", value)

			line = "->2. %s: %s" % (texts("ct"), value[14:len(value)])
			popup.modline(4, line)

			lang_msg("ct", tokens)
		elif type[1] == "tg":
			es.set("sm_skins_default_t_gk", value)
			es.keysetvalue("soccer_mod_settings", "skins", "model_t_gk", value)

			line = "->3. %s: %s" % (texts("t_gk"), value[14:len(value)])
			popup.modline(5, line)

			lang_msg("t_gk", tokens)
		elif type[1] == "cg":
			es.set("sm_skins_default_ct_gk", value)
			es.keysetvalue("soccer_mod_settings", "skins", "model_ct_gk", value)

			line = "->4. %s: %s" % (texts("ct_gk"), value[14:len(value)])
			popup.modline(6, line)

			lang_msg("ct_gk", tokens)

		es.keygroupsave("soccer_mod_settings", "soccer_mod")

		popuplib.send("sm_popup_admin_settings_skins", userid)

def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_skins")