﻿import es
import gamethread
import langlib
import playerlib
import popuplib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/shout/messages_shout.ini")

used = []

# ******************** Load ********************
def load():
	create_popup()

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/shout/popup_shout.ini")

	popup = popuplib.create("sm_popup_shout")

	popup.addline(text("title"))
	popup.addline("1. %s" % (text("foul")))
	popup.addline("2. %s" % (text("goal")))
	popup.addline("3. %s" % (text("ole")))
	popup.addline("4. %s" % (text("pass")))
	popup.addline("5. %s" % (text("save")))
	popup.addline("6. %s" % (text("shot")))
	popup.addline("0. %s" % (common("close")))

	popup.select(1, shout)
	popup.select(2, shout)
	popup.select(3, shout)
	popup.select(4, shout)
	popup.select(5, shout)
	popup.select(6, shout)
	popup.submenu(7, "sm_popup_shout")
	popup.submenu(8, "sm_popup_shout")
	popup.submenu(9, "sm_popup_shout")

# ******************** Commands ********************
def cmd_shout():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if player.isdead == 0:
			popuplib.send("sm_popup_shout", userid)
		else:
			es.tell(userid, "#green", messages("dead", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", common("not_allowed", tokens, player.get("lang")))

# ******************** Popup choices ********************
def shout(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if player.isdead == 0:
		if player.steamid not in used:
			used.append(player.steamid)

			if choice == 1:
				sound = es.ServerVar("sm_shout_sound_foul")
			elif choice == 2:
				sound = es.ServerVar("sm_shout_sound_goal")
			elif choice == 3:
				sound = es.ServerVar("sm_shout_sound_ole")
			elif choice == 4:
				sound = es.ServerVar("sm_shout_sound_pass")
			elif choice == 5:
				sound = es.ServerVar("sm_shout_sound_save")
			else:
				sound = es.ServerVar("sm_shout_sound_shot")

			es.emitsound("player", userid, sound, "1.0", "1.0")

			gamethread.delayed(es.ServerVar("sm_shout_delay"), used.remove, (player.steamid))
	else:
		es.tell(userid, "#green", messages("dead", tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_shout")