﻿# SOCCER MOD 2010
#
# CREDITS:
#
# SCRIPT:
# - FCD | Cor Lems
# - FCD | Marco Boogers
#
# SKINS:
# - FCD | Termi
#
# TRAINING BALL MODEL:
# - FCD | Marco Boogers
#
# FOR THE LATEST VERSION OF SOCCER MOD GO TO:
# http://addons.eventscripts.com/addons/view/soccer_mod_2010
#
# *************************************************************************
# *************************************************************************
# DO NOT EDIT THIS FILE OR ANY OTHER FILE IN ONE OF THE SUBDIRECTORIES!!!!!
# GO TO cstrike/cfg/soccer_mod TO CHANGE SETTINGS!!!!!
# *************************************************************************
# *************************************************************************

import es
import langlib
import os
import playerlib

required = [
	"cfg",
	"cmd",
	"admin",
	"downloads",
	"info",
	"settings",
	"vote"
]

modules = [
	"cap",
	"match",
	"player",
	"referee",
	"shout",
	"skins",
	"sprint",
	"training"
]

files = [
	"downloads.cfg",
	"es_soccer_mod_admins_db.txt",
	"es_soccer_mod_maps_db.txt",
	"es_soccer_mod_settings_db.txt",
	"es_soccer_mod_skins_db.txt",
	"ranking.db",
	"soccer_mod.cfg"
]

files_modules = [
	"cap.cfg",
	"match.cfg",
	"referee.cfg",
	"shout.cfg",
	"skins.cfg",
	"sprint.cfg",
	"training.cfg"
]

messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/messages.ini")

# ******************** Load ********************
def load():
	path = "cstrike/cfg/soccer_mod/"
	for item in os.listdir(path):
		if item not in files:
			try:
				os.remove(path + str(item))
			except OSError:
				error = 1

	path = "cstrike/cfg/soccer_mod/modules/"
	for item in os.listdir(path):
		if item not in files_modules:
			try:
				os.remove(path + str(item))
			except OSError:
				error = 1

	for row in required:
		es.load("soccer_mod_2010/%s" % (row))

	for row in modules:
		if es.ServerVar("sm_module_%s_on" % (row)) == 1:
			es.load("soccer_mod_2010/%s" % (row))

	es.set("soccer_mod_2010_version", 1.06)
	es.makepublic("soccer_mod_2010_version")

	es.msg("#green", "Soccer Mod 2010 loaded.")

# ******************** Events ********************
def es_map_start(event_var):
	if es.exists("key", "soccer_mod_maps", event_var["mapname"]) == 1:
		es.set("soccer_mod_allowed", 1)
		es.server.queuecmd("phys_pushscale 900")
	else:
		es.set("soccer_mod_allowed", 0)
		es.server.queuecmd("phys_pushscale 1")

def player_activate(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		tokens = {}
		tokens["mod"] = "SOCCER MOD 2010"
		tokens["command"] = es.ServerVar("sm_cmd_info")

		player = playerlib.getPlayer(event_var["userid"])

		message = str(messages("uses_soccer_mod", tokens, player.get("lang"))) + "\n \n"
		message += str(messages("info", tokens, player.get("lang")))

		es.menu(10, int(event_var["userid"]), message)

# ******************** Unload ********************
def unload():
	for row in required:
		es.unload("soccer_mod_2010/%s" % (row))

	for row in modules:
		if es.ServerVar("sm_module_%s_on" % (row)) == 1:
			es.unload("soccer_mod_2010/%s" % (row))

	es.msg("#green", "Soccer Mod 2010 unloaded.")