﻿import es
import gamethread
import langlib
import playerlib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/sprint/messages_sprint.ini")

used = []

# ******************** Commands ********************
def cmd_sprint():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if player.steamid not in used:
			used.append(player.steamid)
			player.setSpeed(es.ServerVar("sm_sprint_speed"))
			es.tell(userid, "#green", messages("use", tokens, player.get("lang")))

			gamethread.delayed(es.ServerVar("sm_sprint_length"), stop, (userid))

			gamethread.delayed(es.ServerVar("sm_sprint_reset"), reset, (userid, player.steamid))
	else:
		es.tell(userid, "#green", common("not_allowed", tokens, player.get("lang")))

# ******************** Functions ********************
def stop(userid):
	if es.exists("userid", userid) == 1:
		tokens = {}
		player = playerlib.getPlayer(userid)
		player.setSpeed(1)
		es.tell(userid, "#green", messages("end", tokens, player.get("lang")))

def reset(userid, steamid):
	used.remove(steamid)

	if es.exists("userid", userid) == 1:
		tokens = {}
		player = playerlib.getPlayer(userid)
		es.tell(userid, "#green", messages("reset", tokens, player.get("lang")))