﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/training/messages_training.ini")

# ******************** Load ********************
def load():
	create_popup()

	es.keygroupcreate("soccer_mod_training")

	es.set("sm_training_goals_disabled", 0)

	es.load("soccer_mod_2010/training/cannon")

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/training/popup_admin_training.ini")

	popup = popuplib.create("sm_popup_admin_training")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")
	popup.addline("->1. %s" % (text("cannon")))
	popup.addline("->2. %s" % (text("spawn")))
	popup.addline("->3. %s" % (text("disable_goals")))
	popup.addline("->4. %s" % (text("enable_goals")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.submenu(1, "sm_popup_admin_training_cannon")
	popup.select(2, spawn_ball)
	popup.select(3, disable_goals)
	popup.select(4, enable_goals)
	popup.submenu(5, "sm_popup_admin_training")
	popup.submenu(6, "sm_popup_admin_training")
	popup.submenu(7, "sm_popup_admin_training")
	popup.submenu(8, "sm_popup_admin_training")
	popup.submenu(9, "sm_popup_admin")

# ******************** Events ********************
def es_map_start(event_var):
	es.set("sm_training_goals_disabled", 0)

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		delete_keygroup()
		es.keygroupcreate("soccer_mod_training")

		if es.ServerVar("sm_training_goals_disabled") == 1:
			players = es.getUseridList()
			length = len(players)
			if length > 0:
				es.server.queuecmd("es_xfire %s trigger_hurt Kill" % (players[random.randint(0, length - 1)]))

def player_disconnect(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if len(es.getUseridList()) < 1:
			es.set("sm_training_goals_disabled", 0)

# ******************** Popup choices ********************
def spawn_ball(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", "soccer_mod_training", player.steamid) == 0:
		if es.ServerVar("match") == 0:
			es.server.queuecmd("es_xprop_physics_create %s %s" % (userid, es.ServerVar("sm_training_model_ball")))

			gamethread.delayed(0.01, create_key, (player.steamid))

			es.tell(userid, "#green", messages("spawn", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages("no_ball_match", tokens, player.get("lang")))
	else:
		ball_index = es.keygetvalue("soccer_mod_training", player.steamid, "ball_index")
		if ball_index > 0:
			es.remove(ball_index)

		es.keydelete("soccer_mod_training", player.steamid)

		es.tell(userid, "#green", messages("remove", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_training", userid)

def disable_goals(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("match") == 0:
		if es.ServerVar("sm_training_goals_disabled") == 0:
			es.server.queuecmd("es_xfire %s trigger_hurt Kill" % (userid))

			es.set("sm_training_goals_disabled", 1)

			tokens["name"] = player.name
			lang_msg("disabled", tokens)
		else:
			es.tell(userid, "#green", messages("already_disabled", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_disable_match", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_training", userid)

def enable_goals(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_training_goals_disabled") == 1:
		es.server.queuecmd("mp_restartgame 1")

		es.set("sm_training_goals_disabled", 0)

		tokens["name"] = player.name
		lang_msg("enabled", tokens)
	else:
		es.tell(userid, "#green", messages("already_enabled", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_training", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def create_key(steamid):
	es.keycreate("soccer_mod_training", steamid)
	es.keysetvalue("soccer_mod_training", steamid, "ball_index", es.ServerVar("eventscripts_lastgive"))

def delete_keygroup():
	if es.exists("keygroup", "soccer_mod_training") == 1:
		es.keygroupdelete("soccer_mod_training")

# ******************** Unload ********************
def unload():
	delete_keygroup()
	popuplib.delete("sm_popup_admin_training")

	es.unload("soccer_mod_2010/training/cannon")