﻿import es
import gamethread
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_vote")

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/vote/messages_vote.ini")

# ******************** Load ********************
def load():
	create_popup()

# ******************** Events ********************
def es_map_start(event_var):
	delete_keygroup()

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/vote/popup_vote.ini")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")
	popup.addline("Question?")
	popup.addline(" ")
	popup.addline("->1. %s" % (common("yes")))
	popup.addline("->2. %s" % (common("no")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, choice)
	popup.select(2, choice)
	popup.submenu(3, "sm_popup_vote")
	popup.submenu(4, "sm_popup_vote")
	popup.submenu(5, "sm_popup_vote")
	popup.submenu(6, "sm_popup_vote")
	popup.submenu(7, "sm_popup_vote")
	popup.submenu(8, "sm_popup_vote")
	popup.submenu(9, "sm_popup_vote")

# ******************** Popup choices ********************
def choice(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("keygroup", "sm_keygroup_vote") == 1:
		if es.exists("key", "sm_keygroup_vote", player.steamid) == 1:
			if int(es.keygetvalue("sm_keygroup_vote", player.steamid, "voted")) == 0:
				es.keysetvalue("sm_keygroup_vote", player.steamid, "voted", 1)

				number = es.ServerVar("sm_vote_number")
				number += 1
				es.set("sm_vote_number", number)

				tokens["name"] = player.name

				if choice == 1:
					value = es.ServerVar("sm_vote_yes")
					value += 1
					es.set("sm_vote_yes", value)

					lang_msg("voted_yes", tokens)

				if choice == 2:
					value = es.ServerVar("sm_vote_no")
					value += 1
					es.set("sm_vote_no", value)

					lang_msg("voted_no", tokens)

				show_vote_time()

				if number >= es.ServerVar("sm_vote_players"):
					end_vote()
			else:
				es.tell(userid, "#green",  messages("already_voted", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages("cant_vote", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_vote_active", tokens, player.get("lang")))

# ******************** Commands ********************
def cmd_vote():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.exists("keygroup", "sm_keygroup_vote") == 1:
			if es.exists("key", "sm_keygroup_vote", player.steamid) == 0:
				es.tell(userid, "#green", messages("cant_vote", tokens, player.get("lang")))
			else:
				if int(es.keygetvalue("sm_keygroup_vote", player.steamid, "voted")) == 0:
					popuplib.send("sm_popup_vote", userid)
				else:
					es.tell(userid, "#green", messages("already_voted", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages("no_vote_active", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", common("not_allowed", tokens, player.get("lang")))

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def start():
	es.set("sm_vote_number", 0)
	es.set("sm_vote_yes", 0)
	es.set("sm_vote_no", 0)

	es.keygroupcreate("sm_keygroup_vote")

	popup.modline(3, es.ServerVar("sm_vote_question"))

	if es.ServerVar("sm_vote_all") == 1:
		myPlayerList = playerlib.getPlayerList("#human")
		for ply in myPlayerList:
			es.keycreate("sm_keygroup_vote", ply.steamid)
			es.keysetvalue("sm_keygroup_vote", ply.steamid, "voted", 0)
			popuplib.send("sm_popup_vote", ply.userid)

		es.set("sm_vote_players", len(myPlayerList))
	else:
		number = 0

		for ply in playerlib.getPlayerList("#human,#t"):
			es.keycreate("sm_keygroup_vote", ply.steamid)
			es.keysetvalue("sm_keygroup_vote", ply.steamid, "voted", 0)
			popuplib.send("sm_popup_vote", ply.userid)
			number += 1

		for ply in playerlib.getPlayerList("#human,#ct"):
			es.keycreate("sm_keygroup_vote", ply.steamid)
			es.keysetvalue("sm_keygroup_vote", ply.steamid, "voted", 0)
			popuplib.send("sm_popup_vote", ply.userid)
			number += 1

		es.set("sm_vote_players", number)

	if es.ServerVar("sm_vote_sounds_on") == 1:
		es.cexec_all("playgamesound", es.ServerVar("sm_vote_sound_start"))

	tokens = {}
	tokens["command"] = es.ServerVar("sm_cmd_vote")
	lang_msg("info", tokens)

	vote_time(es.ServerVar("sm_vote_length"))

def vote_time(time):
	if es.exists("keygroup", "sm_keygroup_vote") == 1:
		minutes = int(time / 60)
		seconds = time - (minutes * 60)
		es.set("sm_vote_minutes", minutes)
		es.set("sm_vote_seconds", seconds)

		show_vote_time()

		if time > 0:
			gamethread.delayed(1, vote_time, (time - 1))
		else:
			end_vote()

def show_vote_time():
	vote_yes = es.ServerVar("sm_vote_yes")
	vote_no = es.ServerVar("sm_vote_no")
	players = es.ServerVar("sm_vote_players")
	minutes = es.ServerVar("sm_vote_minutes")
	seconds = es.ServerVar("sm_vote_seconds")

	es.set("sm_vote_yes_percentage", int(round((float(vote_yes) / float(players)), 0)) * 100)

	tokens = {}
	for player in playerlib.getPlayerList("#human"):
		number = es.ServerVar("sm_vote_number")
		if seconds < 10:
			message = "%s:0%s | %s: %s/%s - %s: %s - %s: %s" % (minutes, seconds, messages("votes", tokens, player.get("lang")), number, players, messages("yes", tokens, player.get("lang")), vote_yes, messages("no", tokens, player.get("lang")), vote_no)
		else:
			message = "%s:%s | %s: %s/%s - %s: %s - %s: %s" % (minutes, seconds, messages("votes", tokens, player.get("lang")), number, players, messages("yes", tokens, player.get("lang")), vote_yes, messages("no", tokens, player.get("lang")), vote_no)
		es.server.queuecmd('usermsg hudhint %s "%s"' % (player.userid, message))

def end_vote():
	if int(es.ServerVar("sm_vote_yes_percentage")) < int(es.ServerVar("sm_vote_percentage")):
		tokens = {}
		lang_msg("not_enough", tokens)
	else:
		es.doblock(es.ServerVar("sm_vote_block"))

	delete_keygroup()

def delete_keygroup():
	if es.exists("keygroup", "sm_keygroup_vote") == 1:
		es.keygroupdelete("sm_keygroup_vote")

# ******************** Unload ********************
def unload():
	delete_keygroup()
	popuplib.delete("sm_popup_vote")